﻿Imports System
Imports System.Collections.Generic
Imports Rhino
Imports Rhino.Commands
Imports Rhino.Geometry
Imports Rhino.Input
Imports Rhino.Input.Custom

Namespace LWS_DemoBugCaptureToBitmap

    Public Class BugCaptureToBitmap
        Inherits Command

        Shared _instance As BugCaptureToBitmap

        Public Sub New()
            ' Rhino only creates one instance of each command class defined in a
            ' plug-in, so it is safe to store a refence in a static field.
            _instance = Me
        End Sub

        '''<summary>The only instance of this command.</summary>
        Public Shared ReadOnly Property Instance() As BugCaptureToBitmap
            Get
                Return _instance
            End Get
        End Property

        '''<returns>The command name as it appears on the Rhino command line.</returns>
        Public Overrides ReadOnly Property EnglishName() As String
            Get
                Return "CaptureToBitmap_TestBug"
            End Get
        End Property

        Protected Overrides Function RunCommand(ByVal doc As RhinoDoc, ByVal mode As RunMode) As Result

            RhinoApp.WriteLine("Capturing view with CaptureToBitmap()...")
            Dim myview As Display.RhinoView = doc.Views.ActiveView
            Dim view_capture = New Display.ViewCapture With {
                .Width = myview.ActiveViewport.Size.Width,
                .Height = myview.ActiveViewport.Size.Height,
                .ScaleScreenItems = False,
                .DrawAxes = False,
                .DrawGrid = False,
                .DrawGridAxes = False,
                .TransparentBackground = False
            }

            Dim img As Drawing.Image = view_capture.CaptureToBitmap(myview)
            Dim path As String = IO.Path.Combine(My.Computer.FileSystem.SpecialDirectories.Temp, "test.jpg")
            Try
                img.Save(path, Drawing.Imaging.ImageFormat.Jpeg)
                System.Diagnostics.Process.Start(path)
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try


            Return Result.Success
        End Function
    End Class
End Namespace